#!/bin/sh
#	This is a shell archive.
#	Run the file through sh to extract its contents.
# shar:	Shell Archiver
#	Run the following text with /bin/sh to create:
#	sem2.s
#	decls-example.s
# This archive created: Tue Nov  7 11:24:47 1989
echo shar: extracting sem2.s '(8259 characters)'
sed 's/^X//' << \SHAR_EOF > sem2.s
X; $Header: sem2.s,v 1.5 84/10/26 15:32:40 mw Exp $
X
X; Example of use of type-checker and syntax-directed transducer
X
X; A Language with Statements
X
X; ************************************************************
X; $Log:	sem2.s,v $
X;;; Tue Apr 11 14:45:50 1989 mw
X;;; Revised for LL version of grammar, Chez scheme version of SPS
X
X; Revision 1.5  84/10/26  15:32:40  mw
X; Cleaned up semantics a little, rearranged and tidied.
X; 
X; Revision 1.4  84/02/27  13:21:26  mw
X; Added notzerop, pr4 example
X; 
X; Revision 1.3  84/02/16  09:53:13  mw
X; comments on grammar modified to match yacc grammar
X; 
X; Revision 1.2  84/01/27  14:48:44  mw
X; Updated to use new define-type-constructor
X; 
X; ************************************************************
X
X; define types for various domains
X
X(define-type-abbrev value int)
X(define-type-abbrev state (state))	; to be defined later
X(define-type-abbrev lvalue (lvalue))	; to be defined later
X(define-type-abbrev ans bool)
X
X(define-type-abbrev ccont (-> (seq state) ans))
X(define-type-abbrev expcont (-> (seq value) ccont))
X(define-type-abbrev env (-> (seq symbol) (union (lvalue) (triv))))
X(define-type-abbrev bcont (-> (seq bool) ccont))
X(define-type-abbrev lcont (-> (seq (lvalue)) ccont))
X(define-type-abbrev dcont (-> (seq env) ccont))
X
X; Typenames beginning with capital letters are associated by
X; convention with nonterminals.
X
X(define-type-abbrev Pgm (-> (seq (list int)) ans))
X(define-type-abbrev Cmd (-> (seq env ccont) ccont))
X(define-type-abbrev Cmdlist Cmd)
X(define-type-abbrev Block Cmd)
X(define-type-abbrev Dcl (-> (seq env dcont) ccont))
X(define-type-abbrev Dcllist Dcl)
X(define-type-abbrev Rhs (-> (seq env expcont) ccont))
X(define-type-abbrev Lhs (-> (seq env lcont) ccont))
X(define-type-abbrev Boolexp (-> (seq env bcont) ccont))
X(define-type-abbrev Ident (-> (seq env lcont) ccont))
X
X; definitions of assorted auxiliary functions
X
X(define-checked terminate
X  (generic (x) (-> (seq x) ccont))
X   (lambda (msg)
X      (lambda (state-token)
X	 (begin
X	    (print msg)
X	    (newline)))))
X
X(define-checked terminate-normally
X   ccont
X   (terminate  (list 'terminate-normally)))
X
X; now define a type (lvalue) with a hidden representation.
X; define-type-constructor can also be used to define generic type
X; constructors, e.g. (a-list x).
X
X(define-type-constructor (lvalue)
X   (pair symbol value)		; the representation.  We are going to use
X				; set-car!, so we can't use union.
X   (lval$new      		; the nil is the list of local generic type
X				; variables.
X      (-> (seq) (lvalue))	; lval$new is a function of no args,
X			        ; returning an lvalue.
X      (lambda ()
X	 (enc (pair 'uninitialized any))))
X   (lval$contents 
X      (-> (seq expcont (lvalue)) ccont)
X      (lambda (k loc)
X	 (lambda (state)	; here the state token is used for
X				; synchronization
X	    (if (eq? (lson (dec loc)) 'uninitialized)
X		((terminate 
X		    (list '|can't-take-contents-of-uninitialized vble|))
X		 state)
X		((k (rson (dec loc)))
X		 state)))))
X   (assign 
X      (-> (seq ccont (lvalue)) expcont)
X      (lambda (kc loc)
X	 (lambda (v)
X	    (lambda (state)
X	       (begin 
X		  (set-car! (dec loc) 'initialized)
X		  (set-cdr! (dec loc) v)
X		  (kc state)))))))
X
X; since lvalues are so sophisticated, we can
X; define (state) simply.  We use an unforgeable token which we pass around
X; for synchronization, a list to represent the input state, and we use real
X; output to represent output.
X
X(define-type-constructor (state)
X   symbol
X   (the-state-token (state) (enc 'the-state-token)))
X
X(define-checked the-input (list int) any)
X
X(define-checked initstate
X   (-> (seq (list int)) state)
X   (lambda (w)
X      (begin
X	 (set! the-input w)
X	 the-state-token)))
X
X; auxiliary functions for environments
X
X(define-checked initenv
X   env
X   (lambda (id) (inR triv)))
X
X(define-checked ext
X   (-> (seq env symbol lvalue) env)
X   (lambda (r id val)
X      (lambda (id1)
X	 (if (eq? id1 id) (inL val) (r id1)))))
X
X(define-checked declare
X   (-> (seq symbol env dcont) ccont)
X   (lambda (id r kr) 
X      (kr (ext r id (lval$new)))))
X
X; auxiliaries for input/output
X
X(define-checked do-read
X   (-> (seq expcont) ccont)
X   (lambda (k)
X      (lambda (state)
X	 (if (null? the-input)
X	     ((terminate (list 'eof-error)) state)
X	     (let ((next (car the-input)))
X		  (begin
X		     (set! the-input (cdr the-input))
X		     ((k next) state)))))))
X
X(define-checked do-print
X   (-> (seq ccont) expcont)
X   (lambda (k)
X      (lambda (v)
X	 (lambda (state)
X	    (begin
X	       (print v)
X	       (newline)
X	       (k state))))))
X
X; coercions
X
X(define-checked rv
X   (-> (seq expcont) lcont)
X   (lambda (k)
X      (lambda (loc)
X	 (lval$contents k loc))))
X
X(define-checked lv
X    (-> (seq lcont) lcont)
X    (lambda (kl) kl))
X
X; here is the syntax-directed transduction
X
X(define-grammar sem2 pgm
X  (pgm					; pgm ::= block
X    (Pgm (Block))			
X    (:blk)
X    (lambda (w)
X      ((:blk initenv terminate-normally)
X       (initstate w))))
X
X  (block				; block ::= (decl-list in stmt-list)
X    (Block (Dcllist 'in Cmdlist 'end))
X    (:dl :sl)	
X    (lambda (r k)
X      (:dl r (lambda (r1) (:sl r1 k)))))
X
X  (null-decl-s				; decl-list ::= <empty>
X    (Dcllist ())
X    ()
X    (lambda (r kr) (kr r)))
X
X  (decl-list				; decl-list ::= decl decl-list
X    (Dcllist (Dcl Dcllist))
X    (:dcl :dl)
X    (lambda (r kr) (:dcl r (lambda (r1) (:dl r1 kr)))))
X
X  (decl					; decl ::= new symbol
X    (Dcl ('new symbol))
X    (name)
X    (lambda (r kr) (declare name r kr)))
X
X  (null-stmt-list			; stmt-list ::= <empty>
X    (Cmdlist ())
X    ()
X    (lambda (r kc) kc))
X
X  (stmt-list				; stmt-list ::= stmt; stmt-list
X    (Cmdlist (Cmd 'semicolon Cmdlist))
X    (:s :sl)
X    (lambda (r kc) (:s r (:sl r kc))))
X
X  (assign-stmt				; stmt ::= (assign lhs rhs)
X    (Cmd ('assign Lhs Rhs))
X    (:lhs :rhs)
X    (lambda (r kc)
X      (:lhs r (lambda (loc) (:rhs r (assign kc loc))))))
X
X  (if-stmt				; stmt ::= (if bool stmt1 stmt2)
X    (Cmd ('if Boolexp Cmd Cmd))
X    (:bool :s1 :s2)
X    (lambda (r kc)
X      (:bool r (lambda (b)
X		 (if b (:s1 r kc) (:s2 r kc))))))
X
X  (while-stmt				; stmt ::= (while bool stmt)
X    (Cmd ('while Boolexp Cmdlist 'end))
X    (:bool :cmdlist)
X    (lambda (r kc)
X      (fix theta
X	   (:bool r (lambda (b)
X		      (if b (:cmdlist r theta) kc))))))
X
X  (read-stmt				; stmt ::= (read lhs)
X    (Cmd ('read Lhs))
X    (:lhs)
X    (lambda (r kc)
X      (:lhs r (lambda (loc)
X		(do-read (assign kc loc))))))
X
X  (print-stmt				; stmt ::= (print rhs)
X    (Cmd ('print Rhs))
X    (:rhs)
X    (lambda (r kc)
X      (:rhs r (do-print kc))))
X
X  (block-stmt				; stmt ::= block
X    (Cmd (Block))
X    (:block)
X    :block)
X
X  (exp-id				; rhs ::= ident
X    (Rhs (Ident))
X    (:ident)
X    (lambda (r k) 
X      (:ident r 
X	(lambda (loc)
X	  (lval$contents k loc)))))
X
X  (const				; rhs ::= int
X    (Rhs (int))
X    (c)
X    (lambda (r k) (k c)))
X 
X  (add1					; rhs ::= add1 rhs
X    (Rhs ('add1 Rhs))
X    (:rhs)
X    (lambda (r k) (:rhs r (lambda (v) (k (+ 1 v))))))
X
X  (sub1					; rhs ::= sub1 rhs
X    (Rhs ('sub1 Rhs))
X    (:rhs)
X    (lambda (r k) (:rhs r (lambda (v) (k (+ -1 v))))))
X
X  (zerop				; boolexp ::= zerop rhs
X    (Boolexp ('zerop Rhs))
X    (:rhs)
X    (lambda (r kb) (:rhs r (lambda (v) (kb (zero? v))))))
X	     
X  (notzerop				; boolexp ::= nzerop rhs
X    (Boolexp ('notzerop Rhs))
X    (:rhs)
X    (lambda (r kb) (:rhs r (lambda (v) (kb (not (zero? v)))))))
X
X  (id					; lhs ::= ident
X    (Lhs (Ident))
X    (:ident)
X    (lambda (r kl) (:ident r (lv kl))))
X
X  (lit-to-id				; id ::= symbol
X    (Ident (symbol))
X    (name)
X    (lambda (r kl)
X      (union-case (r name)
X	kl
X	(lambda (triv) (terminate (list 'undeclared-variable name))))))
X     
X  )
X
X
X
X; two sample programs
X
X(define pr1 "in print 3; end")		; a block with no declarations
X
X(define pr2 "new x in print 3; assign x 4; print x;")
X
X(define test1			; run pr1 on input (1 2 3)
X    (lambda ()
X	((sem2 pr1) '(1 2 3))))
X
X(define pr3
X    "new a new b in assign a 1; assign b 1;
X	 read b ; if zerop b
X		      in print 0 ; print a; print b; end
X		      in print 1; print b; print a; end;
X		      end")
X
X(define pr4
X   "new x new sum in
X       read x;
X       print x;
X       assign sum 0;
X       while notzerop x
X	     print sum;
X	     assign sum add1 add1 sum;
X	     assign x sub1 x;
X             end;
X       print sum; end")
SHAR_EOF
if test 8259 -ne "`wc -c sem2.s`"
then
echo shar: error transmitting sem2.s '(should have been 8259 characters)'
fi
echo shar: extracting decls-example.s '(5264 characters)'
sed 's/^X//' << \SHAR_EOF > decls-example.s
X;;; ***********************************
X;;; * Dino P. Oliva                   *
X;;; * A simple recursive language     *
X;;; * Version 3.0 - The final version *
X;;; **************************************************
X;;; * Instructions:                                  *
X;;; * 1] Get into SPS                                *
X;;; * 2] Load this file                              *
X;;; * 3] Execute thunk 'boot-sys'                    *
X;;; * 4] Sample runs are in thunks 'pgm-1' to 'pgm6' *
X;;; **************************************************
X
X; Type information
X
X
X; Basic Types
X
X(define-type-abbrev Val Number)
X
X
X; Production types
X
X(define-type-abbrev Exp (-> (seq Env) (-> (seq E-cont) Val)))
X(define-type-abbrev Assert (list Decl))
X(define-type-abbrev Decl (pair Id Exp))
X(define-type-abbrev Id symbol)
X(define-type-abbrev Number int)
X
X
X; Types of continuations
X
X(define-type-abbrev E-cont (-> (seq Val) Val))
X
X; Environment types (envs as contours)
X
X(define-type-abbrev Env (-> (seq Id) (-> (seq E-cont) Val)))
X
X
X;;; **********************************************************************
X
X; Basic functions
X
X(declare-unchecked assoc () (-> (seq Id Assert) Decl))
X
X(define-unchecked defined?
X  (-> (seq Decl) bool)
X  (lambda (dec)
X    (if (null? dec) nil t)))
X
X(define-checked Y-1
X  (-> (seq (-> (seq Env) Env)) Env)
X  (lambda (f)
X    (let ([g (lambda (x) (lambda (x1) ((f (x x)) x1)))])
X      (g g))))
X
X(define-checked init-env
X  Env
X  (lambda (id) 
X    (lambda (cont) -1)))
X
X(define-checked init-cont
X  Cont
X  (lambda (val) val))
X
X(define-checked extend-contour
X  (-> (seq Assert Env) Env)
X  (lambda (assert env)
X    (lambda (id) 
X      (let ((lu (assoc id assert)))
X	(if (defined? lu) ((rson lu) env) (env id))))))
X
X;(define-checked extend-rec-contour 
X;  (-> (seq Assert Env) Env)
X;  (lambda (assert env)
X;    (lambda (id) 
X;      (let ([lu (assoc id assert)])
X;	(if (defined? lu) 
X;	    ((rson lu) (Y-1 (lambda (env2) (extend-rec-contour assert env))))
X;	    (env id))))))
X
X;;; This seems to be a little more interesting.
X
X(define-checked extend-rec-contour 
X  (-> (seq Assert Env) Env)
X  (lambda (assert env)
X    (Y-1 (lambda (env2)
X	   (lambda (id) 
X	     (let ([lu (assoc id assert)])
X	       (if (defined? lu) ((rson lu) env2) (env id))))))))
X
X
X;;; ******************************************************************
X
X(define-checked fetch
X  (-> (seq Id) Exp)
X  (lambda (id)
X    (lambda (env)
X      (lambda (e-cont)
X	((env id) e-cont)))))
X
X(define-checked return-val
X  (-> (seq Number) Exp)
X  (lambda (num)
X    (lambda (env)
X      (lambda (e-cont)
X	(e-cont num)))))
X
X(define-checked return-let
X  (-> (seq Assert Exp) Exp)
X  (lambda (assert exp)
X    (lambda (env)
X      (lambda (e-cont)
X	((exp (extend-contour assert env)) e-cont)))))
X
X(define-checked return-letrec
X  (-> (seq Assert Exp) Exp)
X  (lambda (assert exp)
X    (lambda (env)
X      (lambda (e-cont)
X      ((exp (extend-rec-contour assert env)) e-cont)))))
X
X(define-checked assert-decl 
X  (-> (seq Decl) Assert) 
X  (lambda (decl)
X    (cons decl nil)))
X
X(define-checked assert-empty-decl
X  Assert
X  nil)
X
X(define-checked assert-decls
X  (-> (seq Decl Assert) Assert)
X  (lambda (decl assert)
X    (cons decl assert)))
X
X(define-checked declare
X  (-> (seq Id Exp) Decl)
X  (lambda (id exp)
X    (pair id exp)))
X
X
X;;; *******************************************************************
X
X; The transducer.
X
X(define-grammar rec-rho
X  Program
X    
X  (program				; <program> ::= <exp>
X    (Program (Exp))
X    (exp)
X    ((exp init-env) init-cont))
X
X  (exp0					; <exp> ::= <number>
X    (Exp (Number))
X    (num)
X    (return-val num))
X
X  (exp1					; <exp> ::= <id>
X    (Exp (Id))
X    (id)
X    (fetch id))
X
X  (exp2					; <exp> ::= let <assert> in <exp>
X    (Exp ('let Assert 'in Exp))
X    (assert exp)
X    (return-let assert exp))
X
X  (exp3					; <exp> ::= letrec <assert> in <exp>
X    (Exp ('letrec Assert 'in Exp))
X    (assert exp)
X    (return-letrec assert exp))
X
X;  (assert0				; <assert> ::= <decl> 
X;    (Assert (Decl))
X;    (decl)
X;    (assert-decl decl))
X
X  (assert0
X    (Assert ())
X    ()
X    assert-empty-decl)
X
X  (assert1				; <assert> ::= <decl> <assert> 
X    (Assert (Decl Assert))
X    (decl assert)
X    (assert-decls decl assert))
X     
X  (decl					; <decl> ::= <id> = <exp>
X    (Decl (Id '= Exp))
X    (id exp)
X    (declare id exp))
X
X  (symbol-to-id			; <id> ::= symbol
X    (Id (symbol))
X    (id)
X    id)
X
X  (int-to-number			; <number> ::= int
X    (Number (int))
X    (num)
X    num)
X  )
X
X
X;;; *******************************************************************
X
X
X
X;;; *******************************************************************
X
X(define run
X  (lambda (string)
X    (print string)
X    (newline)
X    (rec-rho string)))
X
X(define pgm-1
X  (lambda ()
X    (run "letrec a = 4 in b")))
X
X(define pgm0
X  (lambda ()
X    (run "let b = 0 in let a = b in a")))
X
X(define pgm1
X  (lambda ()
X    (run "let b = 1 in letrec a = b in a")))
X
X(define pgm2
X  (lambda ()
X    (run "letrec b = 2 in let a = b in a")))
X
X(define pgm3
X  (lambda ()
X   (run "letrec b = 3 in letrec a = b in a")))
X
X(define pgm4
X  (lambda ()
X    (run "letrec a = b b = 4 c = a in c")))
X
X(define pgm5
X  (lambda ()
X    (run "let a = 5 in let a = 6 b = a in b")))
X
X(define pgm6
X  (lambda ()
X    (run "let a = 5 in letrec a = 6 b = a in b")))
X
X
X
SHAR_EOF
if test 5264 -ne "`wc -c decls-example.s`"
then
echo shar: error transmitting decls-example.s '(should have been 5264 characters)'
fi
#	End of shell archive
exit 0
